/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2008, 2013 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
 
var m_isUSMiUtilDebug = false;
var m_alertUserWhenAJAXCompletes = false;
var m_alertUserSoundWaveId="beepId";
var m_showProcessingDivTimeout = null; //126197
var m_showProcessingDivText = ""; //126197
var m_imageResourcePath = ""; //126197

if (m_waiting == undefined) {
    var m_waiting = false;
}

if (m_wsCallbackQueue == undefined) {
    var m_wsCallbackQueue = new Array();
}

if (m_showProcessingDivTimeoutMillis == undefined) {
	var m_showProcessingDivTimeoutMillis = -1; //126197
}

var timer = {
  time: 0,
  timing: false,
  now: function(){ return (new Date()).getTime(); },
  start: function(){ this.timing = true; this.time = this.now(); },
  stop: function(){ this.timing = false; return this.now()-this.time; },
  isTiming: function(){ return this.timing; }
};

function waitState(waiting) {
	var glassPane = getGlassPane();
	if(waiting) {
        m_waiting = true;
		if (m_isUSMiUtilDebug) {
			timer.start();
		}
		/* Using document.body.clientWidth/Height results in a glass pane that is too
		 * small sometimes (especially in the topology view) when large hunks of the page
		 * can be scrolled off.
		glassPane.style.width = document.body.clientWidth;
		glassPane.style.height = document.body.clientHeight; */

		var glassPaneWidth, glassPaneHeight;
		//Want to know which is BIGGER of scrollHeight and offsetHeight
		var height1 = document.body.scrollHeight;
		var height2 = document.body.offsetHeight;
		if (height1 > height2) // all but Explorer Mac
		{
			glassPaneHeight = document.body.scrollHeight;
		}
		else // Explorer Mac;
		     //would also work in Explorer 6 Strict, Mozilla and Safari
		{
			glassPaneHeight = document.body.offsetHeight;
		}

		//Want to know which is BIGGER of scrollWidth and offsetWidth
		var width1 = document.body.scrollWidth;
		var width2 = document.body.offsetWidth;
		if (width1 > width2) // all but Explorer Mac
		{
			glassPaneWidth = document.body.scrollWidth;
		}
		else // Explorer Mac;
		     //would also work in Explorer 6 Strict, Mozilla and Safari
		{
			glassPaneWidth = document.body.offsetWidth;
		}

		//Set the glass pane dimensions
		glassPane.style.width = glassPaneWidth;
		glassPane.style.height = glassPaneHeight;
		
		//112232 -- set cursor to wait state since we toggle back to default when we hide the glass pane
		glassPane.style.cursor = "wait";  
		
		//Show the glass pane
		glassPane.style.display = '';
		
		//126197 -- create a div to hold a processing/waiting indicator...
		var glassPaneProcessingIndicator = document.getElementById("glassPaneProcessingIndicator");
		if (glassPaneProcessingIndicator != null) {
			//Cancel the current timeout if one exists
			if (m_showProcessingDivTimeout != null) {
				try {
					clearTimeout(m_showProcessingDivTimeout);
				} catch (err) {
					//Some small chance that m_showProcessingDivTimeout could be null if displayGlassPaneProcessingIndicator() were called just before clearTimeout
				}
				m_showProcessingDivTimeout = null;
			}
		
			//Hide glass pane processing indicator
			glassPaneProcessingIndicator.style.display = 'none'; 
		
			if (m_showProcessingDivTimeoutMillis >= 0) {
				m_showProcessingDivTimeout = setTimeout(function() {displayGlassPaneProcessingIndicator();}, 
														m_showProcessingDivTimeoutMillis);
			}
		}
	} else {
		glassPane.style.cursor = "default"; //112232 -- explicitly set back to default or sometime in IE the cursor sticks in wait state until moved
		glassPane.style.width = "0px";
		glassPane.style.height = "0px";
		glassPane.style.display = 'none';
		if (m_showProcessingDivTimeout != null) { //126197: //Cancel the current timeout if one exists
			try {
				clearTimeout(m_showProcessingDivTimeout);
			} catch (err) {
				//Some small chance that m_showProcessingDivTimeout could be null if displayGlassPaneProcessingIndicator() were called just before clearTimeout
			}
			m_showProcessingDivTimeout = null;
		}
		if (m_isUSMiUtilDebug && timer.isTiming()) {
			var since = timer.stop();

			reportPerformanceStats(since);
			appendPerformanceTextArea("Time = " + since + " ms (or " + (since/1000) + " s)");
		}
        m_waiting = false;
        if (m_alertUserWhenAJAXCompletes) {
            beep();
        }
        if (m_wsCallbackQueue != null) {
        	try {
                if (m_wsCallbackQueue.length > 0) {
                    var wsCallback = m_wsCallbackQueue.shift();
                    wsCallback();
                    wsCallback = null;
                }
            } catch (e) {
                // 196907 logging instead of using alert because alert doesn't help users and is intrusive 
                if (window.console) {
                    if (typeof window.console.debug !== 'undefined') {
                        // Firebug
                        console.debug(e.message);
                    } else if (typeof window.console.log !== 'undefined') {
                        // Internet Explorer with Developer Tools
                        console.log(e.message);
                    }
                }
            }
        }
	}
}

function getGlassPane() {
	var glassPane = document.getElementById("glassPane");
	if(!glassPane) {
		glassPane = document.createElement("div");
		glassPane.setAttribute("id", "glassPane");
		glassPane.setAttribute("name", glassPane.id);
		glassPane.style.position = "absolute";
		glassPane.style.top = "0px";
		glassPane.style.left = "0px";
		//Tried to set the zIndex to hX_6.BIG_ZINDEX + 1, but that didn't work. We want a value bigger than
		//the hX_6.BIG_ZINDEX constant because we want the glasspane to appear on top of modal panel dialogs
		//as well. NEW APPEND (2-19-08): Also, want it above any context menus that might be showing, so making
		//it even bigger (from 20000 to 100000).
		glassPane.style.zIndex = 100000;
		glassPane.style.borderWidth = "0px";
		glassPane.style.borderStyle = "none";
		glassPane.style.padding = "0px";
		glassPane.style.margin = "0px";
		glassPane.style.fontSize = "1px";
	    
	    //124682 -- problems loading the blank.gif cause big problems in FF. So, let's only do in IE. (You may ask why we leave it for IE? Well, it seems
	    //if we don't leave this in place for IE that 112232 comes back.)
		var userAgent = navigator.userAgent.toLowerCase();
        var isIE = ( userAgent.indexOf( "msie" ) != -1 );
		if (isIE) {
	    		glassPane.style.backgroundImage = "url('../img/blank.gif')";
	    		glassPane.style.backgroundRepeat = "repeat";
		}
		
		document.body.appendChild(glassPane);
		
		//126197: Main processing div
		glassPaneProcessingIndicator = document.createElement("div");
		glassPaneProcessingIndicator.setAttribute("id", "glassPaneProcessingIndicator");
		glassPaneProcessingIndicator.setAttribute("name", glassPaneProcessingIndicator.id);
		glassPaneProcessingIndicator.style.position = "absolute";
		glassPaneProcessingIndicator.style.borderWidth = "1px";
		glassPaneProcessingIndicator.style.borderStyle = "solid";
		glassPaneProcessingIndicator.style.padding = "0px";
		glassPaneProcessingIndicator.style.margin = "0px";
		glassPaneProcessingIndicator.style.backgroundColor = "#FFFFFF"; 
		glassPaneProcessingIndicator.style.display = 'none';
		glassPane.appendChild(glassPaneProcessingIndicator);

		//Create a table to put a processing image in one cell and some proceessing text in the other cell
		glassPaneProcessingTable = document.createElement("table");
		glassPaneProcessingTable.setAttribute("id", "glassPaneProcessingTable");
		glassPaneProcessingTable.setAttribute("name", glassPaneProcessingTable.id);
		glassPaneProcessingTableBody = document.createElement("tbody");
		glassPaneProcessingTableBodyRow = document.createElement("tr");
		
		//1st cell -- for image
		glassPaneProcessingTableBodyRowCell1 = document.createElement("td");
		glassPaneProcessingIndicatorImage = document.createElement("img");
		glassPaneProcessingIndicatorImage.setAttribute("src", m_imageResourcePath + "wait.gif");
		glassPaneProcessingIndicatorImage.setAttribute("width", "38px");
		glassPaneProcessingIndicatorImage.setAttribute("height", "38px");
		glassPaneProcessingIndicatorImage.setAttribute("alt", "Working");
		glassPaneProcessingTableBodyRowCell1.appendChild(glassPaneProcessingIndicatorImage);
		
		//2nd cell -- for text
		glassPaneProcessingTableBodyRowCell2 = document.createElement("td");
		glassPaneProcessingTableBodyRowCell2.innerHTML = m_showProcessingDivText;
		
		//Put the table together
		glassPaneProcessingTableBodyRow.appendChild(glassPaneProcessingTableBodyRowCell1);
		glassPaneProcessingTableBodyRow.appendChild(glassPaneProcessingTableBodyRowCell2);
		glassPaneProcessingTableBody.appendChild(glassPaneProcessingTableBodyRow);
		glassPaneProcessingTable.appendChild(glassPaneProcessingTableBody);
		glassPaneProcessingIndicator.appendChild(glassPaneProcessingTable);
	}
	return glassPane;
}

function displayGlassPaneProcessingIndicator() {
	if (m_showProcessingDivTimeout != null) {
		//Clear out the timer variable
		m_showProcessingDivTimeout = null; 

		var glassPaneProcessingIndicator = document.getElementById("glassPaneProcessingIndicator");
		if (glassPaneProcessingIndicator != null) {
			//Show the processing div
			glassPaneProcessingIndicator.style.display = '';
			
			//Center the processing indicator within the glass pane
			var glassPaneProcessingIndicatorHeight = glassPaneProcessingIndicator.clientHeight;
			var glassPaneProcessingIndicatorWidth = glassPaneProcessingIndicator.clientWidth;
			glassPaneProcessingIndicator.style.top 
				= (document.body.clientHeight-glassPaneProcessingIndicatorHeight)/2 + "px";
			glassPaneProcessingIndicator.style.left 
				= (document.body.clientWidth-glassPaneProcessingIndicatorWidth)/2 + "px";							
		}
	}
}

function isWaiting() {
    return m_waiting;
}

function setWsCallback(wsCallback) {
    m_wsCallbackQueue.push(wsCallback);
}

function setUSMiUtilDebug(usmiUtilDebug) {
	m_isUSMiUtilDebug = usmiUtilDebug;
}

function isUSMiUtilDebug() {
	return m_isUSMiUtilDebug;
}

function updateInputHidden(inputHiddenElementId, newValue) {
  //alert(inputHiddenElementId+' '+newValue);
  var inputHiddenElement = document.getElementById(inputHiddenElementId);
  if (inputHiddenElement) {
    //alert("\ninputHiddenElement newValue: "+newValue);
    //println("\ninputHiddenElement newValue: "+newValue);
    inputHiddenElement.value = newValue;
  }
  return true;
}

function updateInnerHtml(inputElementId, newValue) {
  var inputElement = document.getElementById(inputElementId);
  if (inputElement) {
    inputElement.innerHTML = newValue;
  }
  return true;
}

function clickElement(elementId) {
  var element = document.getElementById(elementId);
  if (element) {
    element.click();
  }
}

function shouldHandleKeyPress(evt,keyCode){
	var key= evt.keyCode || evt.which;
	return (key==keyCode);
}

function handleKeyPress(evt, keyCode, callBack){
	if (shouldHandleKeyPress(evt, keyCode)) {
		if (callBack) {
			callBack();
		}
	}
}

function shouldHandleKeysPress(evt, keyCode1, keyCode2){
	var key= evt.keyCode || evt.which;
	return (key==keyCode1 || key==keyCode2);
}

function handleKeysPress(evt, keyCode1, keyCode2, callBack){
	if (shouldHandleKeysPress(evt, keyCode1, keyCode2)) {
		if (callBack) {
			callBack();
		}
	}
}

function clickElementOnEnter(evt, elementId) {
	if (shouldHandleKeyPress(evt, 13)) {
		setTimeout("clickElement('" + elementId + "');", 0);
	}
}

/**** DIALOGS FUNCTIONS ****/
function StringBuffer() {
   this.buffer = [];
}

StringBuffer.prototype.append = function append(string) {
  this.buffer.push(string);
  return this;
};

StringBuffer.prototype.toString = function toString() {
  return this.buffer.join("");
};

function getColumnsDialogRequestString(dialogId) {

  var newValue = "";
  var buf = new StringBuffer();
  var selectElements = getDialogSelectElements(dialogId);
  for (var i = 0; i < selectElements.length; i++) {
    //println("\nstart of selectElement");
    var options = selectElements[i].options;
    var optionValue = "";
    //println("\n options length: "+options.length);
    for (var x = 0; x < options.length; x++) {

      //TODO appending is breaking the JavaScript
      optionValue = options[x].value;
      buf.append(optionValue);
      buf.append("!");
      //println("\noptionValue: "+optionValue);
    }
    //println("\nend of selectElement");
    buf.append(":");
  }
  newValue = buf.toString();
  //println("\nnewValue length: "+newValue.length);
  return newValue;
}

function getSortsDialogRequestString(dialogId) {
  var dialog = hX_6.getComponentById(dialogId);

  var newValue = "";
  var selectElements = getDialogSelectElements(dialogId);
  for (var i = 0; i < selectElements.length; i++) {
   newValue += selectElements[i].value + ":";
   //println("\nselectValue: "+selectElements[i].value);
  }
  return newValue;
}

function getDialogSelectElements(dialogId) {
  var dialog = hX_6.getComponentById(dialogId);
  if (dialog && dialog.DOMobj) {
    return dialog.DOMobj.getElementsByTagName("select");
  }
  return null;
}

function clearHiddenIds() {
  if (typeof hx_jsHidden != "undefined") {
    hx_jsHidden.clearHiddenIds();
  }
}

HxG_6.prototype.HxHidden = function () {
 	this.hiddenIds=new Array();
};

HxG_6.prototype.HxHidden.prototype.registerHiddenId = function(hiddenId) {
  this.hiddenIds[this.hiddenIds.length]=hiddenId;
};

HxG_6.prototype.HxHidden.prototype.clearHiddenIds = function() {
  for (var i=0; i < this.hiddenIds.length; i++) {
    updateInputHidden(this.hiddenIds[i], '');
  }
};

//***************************************************************
// Other misc utils
//***************************************************************
function setButtonEnabled(buttonClientId, enabled) {
	var button = document.getElementById(buttonClientId);

	if (button != null) {
		button.disabled = !enabled;
        if (enabled) {
            button.className = "commandButton";
        }else{
            button.className = "commandButton_disabled";
        }
	}
}

function doHxDataTableExInit() {
	if(typeof(HxDataTableEx) !='undefined') {
		hX_6.broadcastEdtInit();
	}
}

//******************************************************************************
// Utilities to help time the portlet's server side time, plus the onLoad time
//******************************************************************************
var m_onLoadBaseTime = 0;
var onLoadTimer = {
  time: 0,
  timing: false,
  now: function(){ return (new Date()).getTime(); },
  start: function(){ this.timing = true; this.time = this.now(); },
  stop: function(){ this.timing = false; return this.now()-this.time; },
  isTiming: function(){ return this.timing; }
};
function startOnLoadTimer(baseTime) {
	if (!onLoadTimer.isTiming()) {
		m_onLoadBaseTime = baseTime;
		onLoadTimer.start();
	}
}

function stopOnLoadTimer() {
	if (onLoadTimer.isTiming()) {
		var tmpOnLoadBaseTime = m_onLoadBaseTime;
		m_onLoadBaseTime = 0;
		var since = onLoadTimer.stop() + tmpOnLoadBaseTime;
		appendPerformanceTextArea("Non-ajax time to onLoad = " + since + " ms (or " + (since/1000) + " s) -- server time = " + (tmpOnLoadBaseTime/1000) + " s");
	}
}

function resetOnLoadTimer() {
	if (onLoadTimer.isTiming()) {
		onLoadTimer.stop();
		m_onLoadBaseTime = 0;
	}
}

//*******************************************************
// Performance measurement helpers
//*******************************************************
function appendPerformanceTextArea(appendStr){
	var performanceTextArea = getPerformanceTextArea();
	if (performanceTextArea) {
		performanceTextArea.value += appendStr + "\n";
	}
	logPerformanceData(appendStr);
}

function clearPerformanceTextArea(){
	var performanceTextArea = getPerformanceTextArea();
	if (performanceTextArea) {
		performanceTextArea.value = "";
	}
}

function getPerformanceTextArea() {
	var performanceTextArea = null;
	if (m_isUSMiUtilDebug) {
		performanceTextArea = document.getElementById("performanceTextArea");
		if (!performanceTextArea) {
			if (m_isUSMiUtilDebug) {
				//Make a text area
				performanceTextArea = document.createElement("TEXTAREA");
				performanceTextArea.setAttribute("id", "performanceTextArea");
				performanceTextArea.setAttribute("name", performanceTextArea.id);
				performanceTextArea.setAttribute("rows", "5");
				performanceTextArea.setAttribute("cols", "100");
				performanceTextArea.setAttribute("readonly", "true");
				
				var clearPerformanceTextAreaButton = document.createElement("INPUT");
   				clearPerformanceTextAreaButton.setAttribute("type", "button");
			    clearPerformanceTextAreaButton.setAttribute("name", "clearPerformanceTextAreaButton");
			    clearPerformanceTextAreaButton.setAttribute("id", clearPerformanceTextAreaButton.id);
			    clearPerformanceTextAreaButton.setAttribute("value", "Clear Perf Data");
			    clearPerformanceTextAreaButton.onclick=clearPerformanceTextArea;

				//Append text area and buttons
				document.body.appendChild(performanceTextArea);
				document.body.appendChild(clearPerformanceTextAreaButton);
			}
		}
	}
	return performanceTextArea;
}
//*******************************************************

//*******************************************************************
// Reusable onClick behavior utility
//*******************************************************************
function dispatchOnClickBehavior(resuableOnClickBehavior, targetAction, behaviorAction, onActionFunction) {
	if (resuableOnClickBehavior == null) {
		resuableOnClickBehavior = getResuableOnClickBehavior();
	}
	resuableOnClickBehavior.setAttribute("target:" + targetAction);
	resuableOnClickBehavior.setAttribute("action:" + behaviorAction);

	if (onActionFunction) {
		resuableOnClickBehavior.setAttribute("function:" + onActionFunction);
	} else {
		resuableOnClickBehavior.setAttribute("function:return true;");
	}

	//Create an event and dispatch the behavior
	var evt;
	if(document.createEvent){
	    evt = document.createEvent("MouseEvents");
	    evt.initEvent( "click", true, true );
	} else {
	    evt = document.createEventObject();
	}
	resuableOnClickBehavior.dispatchBehavior(this, evt);
	return true;
}

function getResuableOnClickBehavior() {
	var reusableBehaviorHiddenInput = getHiddenInputForReusableBehaviors();
	var reusableOnClickBehavior = hX_6.getBehaviorById(reusableBehaviorHiddenInput.id, "generic", "onclick");
	if (!reusableOnClickBehavior) {
		//Add a reusable behavior to the hidden input
		reusableOnClickBehavior = new hX_6.JSFBehaviorGeneric();
        hX_6.addBehavior(reusableBehaviorHiddenInput.id, "onclick", reusableOnClickBehavior);
	}
	return reusableOnClickBehavior;
}

function getHiddenInputForReusableBehaviors() {
	var reusableBehaviorHiddenInput = document.getElementById("reusableBehaviorHiddenInput");
	if (!reusableBehaviorHiddenInput) {
		//Make hidden input
		reusableBehaviorHiddenInput = document.createElement("INPUT");
		reusableBehaviorHiddenInput.setAttribute("id", "reusableBehaviorHiddenInput");
		reusableBehaviorHiddenInput.setAttribute("name", reusableBehaviorHiddenInput.id);
		reusableBehaviorHiddenInput.setAttribute("type", "hidden");

		//Append hidden input
		document.body.appendChild(reusableBehaviorHiddenInput);
	}
	return reusableBehaviorHiddenInput;
}


function beep() {
	var userAgent = navigator.userAgent.toLowerCase();
        var isIE = ( userAgent.indexOf( "msie" ) != -1 );
	if (!isIE) {
		if ((navigator.javaEnabled != null) && (navigator.javaEnabled())) {
    			java.awt.Toolkit.getDefaultToolkit().beep();
    			java.awt.Toolkit.getDefaultToolkit().beep();
    			java.awt.Toolkit.getDefaultToolkit().beep();
		}
	}
	else {
		var beepObj=document.getElementById(m_alertUserSoundWaveId);
		if (beepObj != null) {
			beepObj.Play();
		}
	}		
	
}

//***************************************************************
// Text Area Helper 
//***************************************************************
function limitTextInField(limitField, limitNum) {
    if (limitField.value.length > limitNum) {
        limitField.value = limitField.value.substring(0, limitNum);
    } 
}

/*******************************
*
* AutoFocusStuff
* 
* AutoFocus has 3 LEVELs of precedence which determine which components gets the focus.
* In a LEVEL after a component has requested focus (setting its id to autoFocusELementId)
* it can't be overwritten until it has been cleared, unless another component with a higher level request focus.
* The 3 LEVELs can be loosely be defined as this (from lowest to highest):
* BASE - a component in the main page
* DIALOG - a component in a dialog
* ATTACH - attached directly on component
* 
*******************************/

var isAutoFocusAttach = false;
var isAutoFocusOnDialog = false;
var autoFocusElementId = null;
var autoFocusPanelDialogId = null;

/**
 * Sets the id of the element to set focus to.
 * If a panelDialogId is pass it means the focus is
 * for an element in a panelDialog.
 * 
 * Sets autoFocusElementId if it is currently null, 
 * thus the first caller to the set is the one that gets the focus.
 * 
 * The above behavior changes if the element requesting focus is on a panelDialog as
 * it is overwriting the autoFocusElementId, the thought is that an element in a dialog should have
 * priority of an element on panel behind the dialog.  
 * Allows last element that requested focus from a panel dialog to get the focus.
 * 
 */
function setAutoFocusElementId(id, panelDialogId) {
  if (isAutoFocusAttach) {
    //a focus requested by attaching it has the highest level of precendende
    //is focus was gained by attaching don't overwrite it
    return;
  }

  if (isAutoFocusOnDialog) {
    //focus has already been requested by a component in a dialog
    //return without overwriting
    return;
  }
  
  if (null != panelDialogId) {
    isAutoFocusOnDialog = true;
    autoFocusPanelDialogId = panelDialogId;
  }

  //allow components that want focus and are in a panelDialog to have precendence
  //set the id of the component that want focus unless it has already been set
	if (autoFocusElementId == null || isAutoFocusOnDialog) {
	    autoFocusElementId = id;
	}
}

/**
 * Attach auto focus has the highest precendence.
 * Intended to be use for direct javascript call, to maintain focus on an element while using ajax.
 */
function attachAutoFocus(id) {
  if (isAutoFocusAttach) {
    return;
  }
  autoFocusElementId = id;
  isAutoFocusAttach = true;
}

/**
 * Sets the autoFocusElementId to null.
 * Clears the id so a new call to setAutoFocusElementId can be succesful.
 */
function clearAutoFocusElementId() {
	autoFocusElementId = null;
	isAutoFocusAttach = false;
	isAutoFocusOnDialog = false;
	autoFocusPanelDialogId=null;
}

/**
 * Sets the initial-focus property on JWL's panelDialog js object.
 * NOTE: Should only be getting call when the panelDialog is shown/opened in the onshow for the dialog.
 */
function doAutoFocusInPanelDialog() {
  if (null != autoFocusPanelDialogId) {
    var panelDialog = hX_6.getComponentById(autoFocusPanelDialogId);
    if (null != panelDialog && null != autoFocusElementId) {
      //set the initial-focus to the component we need it for
      panelDialog.setAttribute("initial-focus:"+autoFocusElementId);
    }
    clearAutoFocusElementId();
  }
}

/**
 * Sets focus for an element on the page.
 * If a dialog is already open/visible clear the autoFocusPanelDialogId and focus the element right away.
 */
function doAutoFocus(){
  if (null != autoFocusPanelDialogId) {
    //if element is on a panelDialog check if the dialog is already visible
    var panelDialog = hX_6.getComponentById(autoFocusPanelDialogId);
    if (null != panelDialog && null != autoFocusElementId) {
      if (panelDialog.visible) {
        //panel is already visible
        //clear dialog id and continue to get focus for element that is requesting it
        autoFocusPanelDialogId = null;
      }
    }
  }

  if (null == autoFocusPanelDialogId) {
    if (autoFocusElementId != null) {
      var autoFocusElement = document.getElementById(autoFocusElementId);
      
      if (null != autoFocusElement) {
	     
        // Allow focusing on outputTexts (rendered as spans) for RTC defect 119694 (CMVC 193728)
        if("span" == autoFocusElement.tagName.toLowerCase())
        {
          autoFocusElement.tabIndex = 0;
        }
	       
        try {
          autoFocusElement.focus();
        } catch (e) {
          //sometimes the element can't get focus which creates an error in IE
          //e.g. check 110732
        }
      }
    }

    clearAutoFocusElementId();
  }
}

function defaultAjaxOnComplete(){
	waitState(false);
	doAutoFocus();
}

//**********************************************************************
// Stuff to do a post operation in a new browser window (see 108711)
//**********************************************************************

// simple data struct for a name/value request parameter pair
function NVP(name, value) {
    this.name = name;
    this.value = value;
}


// submitForm
// opens a new window which submits a form to the remote launch servlet
// -in:
//   action - url to submit form to, ie http://9.60.92.246:8080/hmc/na/remotectl/launchTask
//   nvps - array of NVP objects, name vlaue pairs
//   target - name of target window
// -out:
//   reference to the target window
function submitRemoteAction(action, nvps, target) {
  // create input tags
  var inputs = "";
  for ( var i = 0; i < nvps.length; i++ ) {
     inputs = inputs + '<input type="hidden" name="'+nvps[i].name+'" value="'+nvps[i].value+'">';
  }
  
  // create html for submit window
  var submitLine;
  var formInfo;
  if (target == '_new') {
    /** for new window, just do a submit, and don't specify a target window name **/
    submitLine = 'w.submit();',
    formInfo   = '<form name="myHiddenForm" method="POST" action="'+action+ '">';
  } else {
    /** target a particular window...we'll post our html from an intermediate window, and want to close that one **/
    submitLine = 'w.submit(); setTimeout(\'window.close()\', 500);',
    formInfo   = '<form name="myHiddenForm" method="POST" action="'+ action + '" target="' + target + '">';
  }

  newWindowHtml = [
    '<html>',
      '<head>',
        '<title></title>',
        '<script>',
          'function submitMyHiddenForm() {',
            'var w;',
            'var userAgent = navigator.userAgent.toLowerCase();',
            'var isIE = ( userAgent.indexOf( "msie" ) != -1 );',
            'var isFirefox = ( userAgent.indexOf( "firefox" ) != -1 );',
            'var isFirefox2 = ( userAgent.indexOf( "firefox/2" ) != -1 );',
            'if ((w = window) &&',
                '(w = w.document) &&',
                '(w = w.forms) &&',
                '(w = w[\'myHiddenForm\']))',
            '{',
              '<!-- submit form (and if !IE and !FF3+ close window) -->',
               submitLine,
              'if (( !isIE && !isFirefox) || (isFirefox2)) { window.close(); }',
              '} else {',
              '<!-- try again in 0.1s -->',
              'setTimeout(\'submitMyHiddenForm()\', 100);',
            '}',
          '}',
        '</script>',
      '</head>', 
     '<body>',  
        formInfo,
          inputs,
        '</form>',
        '<script>',
          'submitMyHiddenForm();',
        '</script>',
      '</body>',
    '</html>'
  ].join('\n');


  // open blank window
  if (target == "_new") {
    var win = window.open("");
  }
  else {
    var win = window.open(
    '',
    'DirectorLaunchPlatform',
    'width=100,height=100,toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=0,resizable=0');
  }

  // use window.document.write to add dynamic html to new window
  if ( win && win.document ) {
      win.document.write(newWindowHtml);
  }

  // return a reference to the target window...
  if (target == "_new")
    return win;
  else {
    var win2 = window.open("", target);
    return win2;
  } 
}

/**
 * Handles an onContextMenu event fired on a column cell.
 * Looks for child that has the oncontextmenu attribute set and dispatches or fires the event on that child.
 */
function onColumnContextMenu(thisEvent) {

  var i, currentNode, attribute;

  var childNodes = getEventTarget(thisEvent).childNodes;  
  if (null == childNodes) {
    return true;
	}

	for (i=0; i < childNodes.length; i++) {
     currentNode = childNodes[i];
	   if (currentNode.nodeType == 1) {
	     attribute = currentNode.attributes['oncontextmenu'];
	     if (null == attribute || null == attribute.nodeValue) {
	       continue;
	     }
	     simulateMouseOnContextMenu(currentNode);
       return false;	
	  }
	}
	return true;
}

/**
 * Gets the target element from the event.
 * On IE the target attribute wasn't always present.
 */
function getEventTarget(event) {

  var targetElement = null;

  if (typeof event.target != "undefined") {
    targetElement = event.target;
  } else {
    targetElement = event.srcElement;
  }

//  while (targetElement.nodeType == 3 && targetElement.parentNode != null) {
//    targetElement = targetElement.parentNode;
//  }
  return targetElement;
}

function reportPerformanceStats(since) {
  //do nothing - placeholder
}

function logPerformanceData(dataStr) {
  //do nothing - placeholder
}

/**
 * Simulates a mouse event of a given type on the node.
 */
function simulateMouseEvent(currentNode, eventType) {
  if (document.createEvent) {
    //DOM event model
    var e = document.createEvent("MouseEvents");
    e.initEvent(eventType, true, false);
    currentNode.dispatchEvent(e);
  
  } else if (document.createEventObject) {
    //IE event model
    var e = document.createEventObject();
    currentNode.fireEvent("on"+eventType, e);
  }
}

function simulateMouseEventCancellable(currentNode, eventType) {
  if (document.createEvent) {
    //DOM event model
    var e = document.createEvent("MouseEvents");
    e.initEvent(eventType, true, true);
   var testME = currentNode.dispatchEvent(e);
  } else 
if (document.createEventObject) {
    //IE event model
    var e = document.createEventObject();
    currentNode.fireEvent("on"+eventType, e);
  }
}

function simulateMouseOnContextMenu(currentNode) {
  simulateMouseEvent(currentNode, "contextmenu");
}

function simulateMouseClick(currentNode) {
  simulateMouseEvent(currentNode, "click");
}

function simulateMouseClickCancellable(currentNode) {
  simulateMouseEventCancellable(currentNode, "click");
}

/**
 * Returns false if the target of the event is a button or a link (stops the default action behavior from running).
 * Otherwise it returns true.
 * 
 * If a button or a link then it simulates a click on the node.
 */
function defaultAction(event) {
  var doDefaultAction = true;
  var target = getEventTarget(event);
  if (target != null && target.nodeType == 1) {
    var tagName = target.tagName;
	  if (tagName == 'INPUT') {
	    var type = target.type;
	    if (type == 'submit' || type == 'button') {
	      doDefaultAction = false;
	      simulateMouseClickCancellable(target);
	    }
	  } else if (tagName == 'A') {
	    doDefaultAction = false;
	    simulateMouseClick(target);
	    
	  } else if (tagName == hX_6._SEL) {
	    if (target.dropDownClicked) {
	      doDefaultAction = false;
	    }
	    //reset to false
	    target.dropDownClicked = false;
	  }
  }
  return doDefaultAction;
}

/**
 * Sets a flag on the JSFImage object indicating that all CSS classes are defined so that it doesn't parse each CSS file.
 * Note: developer needs to ensure that in fact all classes have been defined.
 */
function disableCSSParsing(id) {
  var menuButtonObject = hX_6.getComponentById(id);
  if (null != menuButtonObject && typeof menuButtonObject.allClassesDefined != "undefined") {
    menuButtonObject.allClassesDefined = true;
  }
}

function HxDefaultAction() {
  //constructor
}

HxDefaultAction.prototype.onPageLoad = function() {
  var dropDownList = document.getElementsByTagName(hX_6._SEL);
  for (var i = 0, currentDropDown = null; i < dropDownList.length; i++) {
    currentDropDown = dropDownList[i];
    currentDropDown.dropDownClicked = false;
    // need to check if onclick / onblur has already been defined?
    // so that it isn't overwriting, not likely
    currentDropDown.onclick = this.dropDownClick;
    currentDropDown.onblur = this.dropDownBlur;
  }
}

HxDefaultAction.prototype.dropDownClick = function() {
  this.dropDownClicked = !this.dropDownClicked;
}

HxDefaultAction.prototype.dropDownBlur = function() {
  this.dropDownClicked = false;  
}

/********* FP starts ***************/
function customPost(url, valuesToSubmit) {

  var getterRequest;

  if (window.XMLHttpRequest) {
    // Mozilla or IE7+
    // if (isJsDebugEnabled) { jsdebug("new FF or IE7+ getter"); }
    getterRequest = new XMLHttpRequest();
  } else if (window.ActiveXObject) {
    // IE6
    // if (isJsDebugEnabled) { jsdebug("new IE6 getter"); }
    getterRequest = new ActiveXObject("Microsoft.XMLHTTP");
  }

  var handlerFunction = getFpReadyStateHandler('fpRequest', getterRequest, fpRequestHandler);
  getterRequest.onreadystatechange = handlerFunction;
  // if (isJsDebugEnabled) { jsdebug("time before ajax call to phase listener: " + new Date()); 
  getterRequest.open("POST", url, false);

  //Send the proper header information along with the request
  var params = "&" + RENDER_ONCE_WITH_AJAX_PARAMS + "=true&" + AJAX_MODE + "=" + MODE_AJAX_FULL + "&fpRequest=true&"+valuesToSubmit;

  getterRequest.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  getterRequest.setRequestHeader("Content-length", params.length);
  getterRequest.setRequestHeader("Connection", "close");
  getterRequest.send(params);
  return false;
}

// from AjaxUtil.java
AJAX_MODE = "$$ajaxmode";
MODE_AJAX_PARTIAL = "axpartial";
MODE_AJAX_FULL = "axfull";
RENDER_ONCE_WITH_AJAX_PARAMS = "com.ibm.isc.jsf.ajax.mode";

function fpRequestHandler(id, response) {
  var startTag = "<fpRequest>";
  var startIndex = response.indexOf(startTag);// + startTag.length;
  var endIndex = response.indexOf("</fpRequest>");
  var result = response.substring(startIndex, endIndex);
  return;
}

function getFpReadyStateHandler(clientId, req, responseTextHandler) {
        // Return an anonymous function that listens to the
        // XMLHttpRequest instance
        return function () {
            // If the request's status is "complete"
            if (req.readyState === 4) {
                // Check that a successful server response was received
                if (req.status === 200) {
                    // Pass the text payload of the response to the
                    // handler function
                    responseTextHandler(clientId, req.responseText);
                } else if (req.status === 0) {
                    // Firefox 3 is returning 0 when queue is killed.
                } else {
                    // An HTTP problem has occurred
                    alert("HTTP error: " + req.status);
                }
            }
        };
}

function customGrab() {

   var sName, v, p, fl=[], fl1=[], fl2=[];
   var f = document.forms[0];
  
   if (f) {
      var str1="1", str2="Submit", hitSubmit=false;
      for (i=0; i<f.elements.length; i++) {
         if ( i==(f.elements.length-1) || f.elements[i].name!=f.elements[i+1].name) {
            p = ( fl2[f.elements[i].name] != null );
            for (j=0; !p && j<fl.length; j++) if (fl[j][0].name==f.elements[i].name) {
               p=true;
            }
            if (!p) {
               v=hX_6.getValuableValue(f.elements[i], true, false);
               if (sName!=null && v==null && sName==f.elements[i].name) {
                  v=str2;
                  hitSubmit=true;
               }
               if (v!=null) {
                  fl2[f.elements[i].name]=str1;
                  if (hX_6.isString(v)) {
                     fl1.push([f.elements[i].name,v]);
                  } else {
                     for (j=0; j<v.length; j++) {
                        fl1.push([f.elements[i].name,v[j]]);
                     }
                  }
               }
            }
         }
         if (sName!=null && !hitSubmit) {
           var imgs=f.getElementsByTagName(hX_6._INP);
           imgs=(imgs.length==undefined)?[imgs]:imgs;
           for (j=0; j<imgs.length; j++) {
             if (imgs[j].type && imgs[j].type.toLowerCase()==hX_6._lIMG && imgs[j].name && imgs[j].name==sName) {
               fl1.push([sName,str2]);
               break;
             }
           }
         }
         if (fl1.length>0) { fl=fl.concat(fl1); fl1=[]; }
      }
   }
   var fieldlistEx = fl;
   delete fl;
   delete fl1;
   delete fl2;
   
   var reqString=hX_6._E;
   if (fieldlistEx!=null) {
      l=fieldlistEx.length;
      for (i=0; i<l; i++) 
         if (fieldlistEx[i]!=null) 
            reqString=reqString + ((reqString.length>0)?hX_6._AMP:hX_6._E) + hX_6.encode(fieldlistEx[i][0]) + hX_6._EQ +  hX_6.encode(fieldlistEx[i][1]);
   return reqString;
}
   
   
   
   
   
   
   
}

function customFP() {
  var valuesToSubmit = customGrab();
  var formAction = document.forms[0].action;
  return customPost(formAction, valuesToSubmit);
}

/********* FP ends ***************/
